Index: /java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 98)
@@ -12,20 +12,20 @@
 
 import javax.swing.*;
+import javax.swing.tree.TreePath;
 
 import java.util.Collection;
-import java.util.HashMap;
+import java.util.IdentityHashMap;
 import java.util.Map;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.dispatching.RunAt;
 
 @SuppressWarnings("serial")
 public class ObjectPanel extends ModifiablePanel implements ControlOwner {
 
-	private static final Logger log = Logger.getLogger(ObjectPanel.class.getName());
+	private static final Logger log = Logger.getLogger(ObjectPanel.class);
 
-	final protected Map<Param, Control> components = new HashMap<Param, Control>();
-	final protected Map<ValueParam, ValueControl> valueControls = new HashMap<ValueParam, ValueControl>();
+	final protected Map<Param, Control> components = new IdentityHashMap<Param, Control>();
+	final protected Map<ValueParam, ValueControl> valueControls = new IdentityHashMap<ValueParam, ValueControl>();
 
 	public ObjectPanel(Panel.Parameters parameters, Collection<Param> params) {
@@ -37,11 +37,12 @@
 		for (final ValueControl c : filterInstanceof(components.values(), ValueControl.class)) {
 			valueControls.put(c.getParam(), c);
+			c.setUserEnabled(true);
 			c.setListener(new ValueControlListener() {
 				@Override
 				public boolean onChange(Object newValue) {
-					if (currentTreeNode == null) {
+					if (currentTreePath == null) {
 						return true;
 					}
-					boolean result = currentTreeNode.changeValue(c, newValue);
+					boolean result = treeAtFrame.changeValue(currentTreePath, c, newValue);
 					refreshControlButtons();
 					return result;
@@ -57,11 +58,11 @@
 	protected void applyChanges() {
 		assert frame.isActive();
-		assert currentTreeNode != null;
-		currentTreeNode.pushLocalChanges();
+		assert currentTreePath != null;
+		treeAtFrame.pushLocalChanges(currentTreePath);
 	}
 
 	protected void refreshControlButtons() {
 		assert frame.isActive();
-		applyButton.setEnabled(currentTreeNode.localChanges != null);
+		applyButton.setEnabled(treeAtFrame.hasLocalChanges(currentTreePath));
 	}
 
@@ -71,28 +72,25 @@
 	@Override
 	public void pullValuesFromLocalToUser(AccessInterface access) {
-		assert currentTreeNode != null;
-		assert currentTreeNode.path.getTree().isActive();
+		assert currentTreePath != null;
 		log.debug("refreshing components");
 
-		final Map<ValueControl, Object> values = new HashMap<ValueControl, Object>();
+		final Map<ValueControl, Object> values = new IdentityHashMap<ValueControl, Object>();
 		for (Map.Entry<ValueParam, ValueControl> e : valueControls.entrySet()) {
 			values.put(e.getValue(), access.get(e.getKey().getId(), Object.class));
 		}
 
-		frame.dispatch(new RunAt<Frame>(frame) {
-			@Override
-			protected void runAt() {
-				if (currentTreeNode.localChanges != null) {
-					for (Map.Entry<ValueControl, Object> e : currentTreeNode.localChanges.entrySet()) {
-						values.put(e.getKey(), e.getValue());
-					}
-				}
-				for (Map.Entry<ValueControl, Object> e : values.entrySet()) {
-					e.getKey().pushValueToUserInterface(e.getValue());
-				}
-				refreshControlButtons();
-				ObjectPanel.this.revalidate();
+
+		NodeAtFrame nodeAtFrame = treeAtFrame.getLocalInfo(currentTreePath);
+		if (nodeAtFrame != null) {
+			for (Map.Entry<ValueControl, Object> e : nodeAtFrame.localChanges.entrySet()) {
+				values.put(e.getKey(), e.getValue());
 			}
-		});
+		}
+
+		for (Map.Entry<ValueControl, Object> e : values.entrySet()) {
+			e.getKey().pushValueToUserInterface(e.getValue());
+		}
+		refreshControlButtons();
+		ObjectPanel.this.revalidate();
 
 	}
@@ -109,34 +107,13 @@
 
 	@Override
-	public TreeNode getCurrentTreeNode() {
-		return super.getCurrentTreeNode();
-	}
-
-	@Override
 	public void handle(FramsticksException exception) {
 		frame.handle(exception);
 	}
 
-	// public void updateValue() {
-	//	//assert panel.getFrame().isActive();
+	@Override
+	public TreePath getCurrentTreePath() {
+		return super.getCurrentTreePath();
+	}
 
-	//	final Node n = panel.getCurrentNode();
-	//	panel.getBrowser().getManager().invokeLater(new Runnable() {
-	//		@Override
-	//		public void run() {
-	//			Object v = n.getAccess().get(param, Object.class);
-	//			if (v == null) {
-	//				v = param.getDef(Object.class);
-	//			}
-	//			final Object fv = v;
-	//			panel.getBrowser().invokeLater(new Runnable() {
-	//				@Override
-	//				public void run() {
-	//					setValueImpl(fv);
-	//				}
-	//			});
-	//		}
-	//	});
-	// }
 
 }
Index: /java/main/src/main/java/com/framsticks/gui/Panel.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 98)
@@ -4,7 +4,9 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
-// import org.apache.log4j.Logger;
 
 import javax.swing.*;
+import javax.swing.tree.TreePath;
+
+import org.apache.log4j.Logger;
 
 /**
@@ -13,4 +15,7 @@
 @SuppressWarnings("serial")
 public abstract class Panel extends JPanel {
+
+	private static final Logger log = Logger.getLogger(Panel.class);
+
 
 	public static class Parameters {
@@ -28,5 +33,5 @@
 	// private static final Logger log = Logger.getLogger(Panel.class.getName());
 
-	protected TreeNode currentTreeNode;
+	protected TreePath currentTreePath;
 	protected final TreeAtFrame treeAtFrame;
 	protected final Frame frame;
@@ -43,16 +48,25 @@
 		this.className = parameters.param.getContainedTypeName();
 		this.setName(parameters.param.getFramsTypeName());
+		log.debug("created panel: " + this);
 	}
 
-	public void setCurrentTreeNode(TreeNode currentTreeNode) {
-		this.currentTreeNode = currentTreeNode;
-	}
 
-	public TreeNode getCurrentTreeNode() {
-		return currentTreeNode;
-	}
 
 	public final Frame getFrame() {
 		return frame;
+	}
+
+	/**
+	 * @return the currentTreePath
+	 */
+	public TreePath getCurrentTreePath() {
+		return currentTreePath;
+	}
+
+	/**
+	 * @param currentTreePath the currentTreePath to set
+	 */
+	public void setCurrentTreePath(TreePath currentTreePath) {
+		this.currentTreePath = currentTreePath;
 	}
 
@@ -70,5 +84,5 @@
 	@Override
 	public String toString() {
-		return uniqueName;
+		return param.toString() + "(" + uniqueName + ")";
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/StatusBar.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 98)
@@ -22,4 +22,5 @@
 	protected JTextField statusBar;
 	protected JPanel swing;
+	protected ExceptionResultHandler exceptionHandler;
 
 	/**
@@ -35,6 +36,9 @@
 			@Override
 			protected void runAt() {
-				log.error("error: " + exception);
+				log.error("error: ", exception);
 				statusBar.setText(exception.getShortMessage(new StringBuilder()).toString());
+				if (exceptionHandler != null) {
+					exceptionHandler.handle(exception);
+				}
 			}
 		});
@@ -70,3 +74,17 @@
 	}
 
+	/**
+	 * @return the exceptionHandler
+	 */
+	public ExceptionResultHandler getExceptionHandler() {
+		return exceptionHandler;
+	}
+
+	/**
+	 * @param exceptionHandler the exceptionHandler to set
+	 */
+	public void setExceptionHandler(ExceptionResultHandler exceptionHandler) {
+		this.exceptionHandler = exceptionHandler;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 98)
@@ -1,5 +1,10 @@
 package com.framsticks.gui;
 
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+
+import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.JoinableDispatcher;
 import com.framsticks.util.dispatching.Task;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
@@ -11,5 +16,5 @@
  * @author Piotr Sniegowski
  */
-public class SwingDispatcher<C> implements Dispatcher<C> {
+public class SwingDispatcher<C> extends AbstractJoinable implements JoinableDispatcher<C> {
 
 	@SuppressWarnings("rawtypes")
@@ -37,7 +42,47 @@
 	@Override
 	public final void dispatch(RunAt<? extends C> runnable) {
-		assert !(runnable instanceof Task);
+		if (runnable instanceof Task) {
+			final Task<?> task = (Task<?>) runnable;
+			Timer timer = new Timer(0, null);
+			timer.addActionListener(new ActionListener() {
+
+				@Override
+				public void actionPerformed(ActionEvent event) {
+					task.run();
+				}
+
+			});
+			timer.setInitialDelay((int) (task.getMoment() - System.currentTimeMillis()));
+			timer.setRepeats(false);
+			timer.start();
+			return;
+		}
 		SwingUtilities.invokeLater(runnable);
 	}
 
+	@Override
+	public String getName() {
+		return "gui";
+	}
+
+	@Override
+	protected void joinableStart() {
+
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		finish();
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 98)
@@ -4,8 +4,8 @@
 
 import com.framsticks.core.Tree;
-import com.framsticks.core.TreeListener;
-import com.framsticks.core.ListChange;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
+import com.framsticks.core.TreeOperations;
+import com.framsticks.gui.controls.ValueControl;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
@@ -14,10 +14,13 @@
 
 import javax.swing.tree.TreePath;
-import com.framsticks.util.dispatching.RunAt;
+
+
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.lang.Casting;
 
 /**
  * @author Piotr Sniegowski
  */
-public class TreeAtFrame implements TreeListener {
+public class TreeAtFrame {
 
 	private static final Logger log = Logger.getLogger(TreeAtFrame.class);
@@ -26,5 +29,7 @@
 	protected final Tree tree;
 	protected final Map<String, Panel> knownPanels = new HashMap<String, Panel>();
-	protected TreeNode rootTreeNode;
+	protected Node rootNode;
+
+	protected Map<TreeNode, NodeAtFrame> nodesStorage = new WeakHashMap<>();
 
 	public TreeAtFrame(Tree tree, Frame frame) {
@@ -90,90 +95,88 @@
 	}
 
-	@Override
-	public void onListChange(Path path, ListChange change) {
+	public boolean hasLocalChanges(TreePath treePath) {
+		NodeAtFrame nodeAtFrame = nodesStorage.get(treePath.getLastPathComponent());
+		if (nodeAtFrame == null) {
+			return false;
+		}
+		return !nodeAtFrame.localChanges.isEmpty();
+	}
+
+	public NodeAtFrame assureLocalInfo(TreePath treePath) {
+		assert frame.isActive();
+		NodeAtFrame nodeAtFrame = nodesStorage.get(treePath.getLastPathComponent());
+
+		if (nodeAtFrame == null) {
+			nodeAtFrame = new NodeAtFrame();
+			nodesStorage.put(Casting.throwCast(TreeNode.class, treePath.getLastPathComponent()), nodeAtFrame);
+		}
+		return nodeAtFrame;
+	}
+
+	public NodeAtFrame getLocalInfo(TreePath treePath) {
+		return nodesStorage.get(treePath.getLastPathComponent());
+	}
+
+	public boolean changeValue(TreePath treePath, ValueControl component, Object newValue) {
+		log.debug("changing value of " + component + " to '" + newValue + "'");
+
+		assureLocalInfo(treePath).localChanges.put(component, newValue);
+
+		return true;
+	}
+
+	public void pushLocalChanges(TreePath treePath) {
+		assert frame.isActive();
+
+		NodeAtFrame nodeAtFrame = nodesStorage.get(treePath.getLastPathComponent());
+		if (nodeAtFrame == null) {
+			return;
+		}
+		Path path = frame.treeModel.convertToPath(treePath);
+
+		for (Map.Entry<ValueControl, Object> e : nodeAtFrame.localChanges.entrySet()) {
+			TreeOperations.set(path, e.getKey().getParam(), e.getValue(), new FutureHandler<Integer>(frame) {
+				@Override
+				protected void result(Integer flag) {
+				}
+			});
+		}
+	}
+
+	public void fillPanelWithValues(TreePath treePath) {
+		NodeAtFrame nodeAtFrame = assureLocalInfo(treePath);
+		if (nodeAtFrame == null) {
+			return;
+		}
+
+		if (nodeAtFrame.panel == null) {
+			return;
+		}
+		Node node = TreeNode.tryGetNode(treePath);
+		if (node == null) {
+			return;
+		}
+		nodeAtFrame.panel.setCurrentTreePath(treePath);
+		nodeAtFrame.panel.pullValuesFromLocalToUser(TreeOperations.bindAccess(node));
+
+		frame.showPanel(nodeAtFrame.panel);
 
 	}
 
-	public TreePath getTreePath(Path path, boolean create) {
-		assert frame.isActive();
-		TreeNode t = rootTreeNode;
-		TreePath result = new TreePath(frame.rootNode).pathByAddingChild(rootTreeNode);
-		List<Node> nodes = path.getNodes();
-		Iterator<Node> i = nodes.iterator();
-		i.next();
-		// Node first = i.next();
+	public void useOrCreatePanel(TreePath treePath) {
+		// node.assureResolved();
+		Node node = TreeNode.tryGetNode(treePath);
 
-		// if (!t.path.isResolved()) {
-		//	t.path = new Path(path.getInstance(), nodes, first);
-		// }
-		while (i.hasNext()) {
-			Node n = i.next();
-			TreeNode r = null;
-			for (TreeNode c : t.childrenIterable()) {
-				if (c.param.getId().equals(n.getParam().getId())) {
-					r = c;
-					break;
-				}
+		NodeAtFrame nodeAtFrame = assureLocalInfo(treePath);
+
+		if (nodeAtFrame.panel == null) {
+			CompositeParam param = node.getParam();
+			nodeAtFrame.panel = findPanel(param.computeAccessId());
+			if (nodeAtFrame.panel == null) {
+				FramsClass framsClass = node.getTree().getInfoFromCache(param.getContainedTypeName());
+				nodeAtFrame.panel = preparePanel(param, framsClass);
 			}
-			if (r == null) {
-				log.debug("missing " + n.getParam().getId() + " in " + t);
-				if (!create) {
-					return result;
-				}
-				Path p = Path.build().tree(path.getTree()).buildUpTo(nodes, n).finish();
-
-
-				log.debug("forced resolution: creating treenode for " + p);
-				TreeNode childNode = new TreeNode(TreeAtFrame.this, p);
-
-				frame.addNode(childNode, t);
-				// frame.treeModel.reload();
-				// t.add(childNode);
-				// frame.treeModel.nodeStructureChanged(t);
-
-				r = childNode;
-			} else {
-				// if (!r.path.isResolved()) {
-				//	r.path = new Path(path.getInstance(), nodes, n);
-				// }
-			}
-			result = result.pathByAddingChild(r);
-			t = r;
 		}
-		return result;
-	}
-
-	@Override
-	public void onFetch(final Path path) {
-		assert tree.isActive();
-		log.trace("fetched " + path);
-
-		frame.dispatch(new RunAt<Frame>(frame) {
-			@Override
-			protected void runAt() {
-
-				TreePath treePath = getTreePath(path, true);
-				assert treePath.getPathCount() == path.size() + 1;
-
-				final TreeNode result = (TreeNode) treePath.getLastPathComponent();
-				// log.trace("found " + result + " == " + path);
-				tree.dispatch(new RunAt<Tree>(frame) {
-					@Override
-					protected void runAt() {
-						result.reactForFetchResult(path, null);
-					}
-				});
-			}
-		});
-	}
-
-	@Override
-	public void onRun(Exception e) {
-
-	}
-
-	@Override
-	public void onStop(Exception e) {
-
+		fillPanelWithValues(treePath);
 	}
 }
Index: /java/main/src/main/java/com/framsticks/gui/TreeModel.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/TreeModel.java	(revision 98)
+++ /java/main/src/main/java/com/framsticks/gui/TreeModel.java	(revision 98)
@@ -0,0 +1,172 @@
+package com.framsticks.gui;
+
+// import java.util.Enumeration;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+
+import javax.swing.event.TreeModelEvent;
+import javax.swing.event.TreeModelListener;
+import javax.swing.tree.TreePath;
+
+import org.apache.log4j.Logger;
+
+
+import com.framsticks.core.Node;
+import com.framsticks.core.Path;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.lang.Casting;
+
+public class TreeModel implements javax.swing.tree.TreeModel {
+	private static final Logger log = Logger.getLogger(TreeModel.class);
+
+
+	protected List<TreeModelListener> listeners = new LinkedList<>();
+
+	protected final Frame frame;
+
+	/**
+	 * @param frame
+	 */
+	public TreeModel(Frame frame) {
+		this.frame = frame;
+	}
+
+	@Override
+	public void addTreeModelListener(TreeModelListener listener) {
+		listeners.add(listener);
+	}
+
+	@Override
+	public AbstractNode getChild(Object parent, int number) {
+		return Casting.assertCast(AbstractNode.class, parent).getChild(number);
+	}
+
+	@Override
+	public int getChildCount(Object parent) {
+		return Casting.assertCast(AbstractNode.class, parent).getChildCount();
+	}
+
+	@Override
+	public int getIndexOfChild(Object parent, Object child) {
+		if ((parent == null) || (child == null)) {
+			return -1;
+		}
+		return Casting.assertCast(AbstractNode.class, parent).getIndexOfChild(Casting.assertCast(AbstractNode.class, child));
+	}
+
+	@Override
+	public MetaNode getRoot() {
+		return frame.rootNode;
+	}
+
+	@Override
+	public boolean isLeaf(Object node) {
+		return Casting.assertCast(AbstractNode.class, node).isLeaf();
+	}
+
+	@Override
+	public void removeTreeModelListener(TreeModelListener listener) {
+		listeners.remove(listener);
+	}
+
+	@Override
+	public void valueForPathChanged(TreePath path, Object value) {
+		throw new UnsupportedOperationException().msg("changing value of tree node");
+	}
+
+
+	protected boolean changing = false;
+
+	public void nodeStructureChanged(TreePath treePath) {
+		if (treePath == null) {
+			return;
+		}
+		assert frame.isActive();
+
+		changing = true;
+		log.debug("changing: " + treePath);
+		// Enumeration<TreePath> expanded = frame.jtree.getExpandedDescendants(treePath);
+		// TreePath selection = frame.jtree.getSelectionPath();
+
+		for (TreeModelListener listener : listeners) {
+			listener.treeStructureChanged(new TreeModelEvent(this, treePath));
+		}
+		// if (expanded != null) {
+		// 	while (expanded.hasMoreElements()) {
+		// 		TreePath expansion = expanded.nextElement();
+		// 		// log.info("reexpanding: " + expansion);
+		// 		frame.jtree.expandPath(expansion);
+		// 	}
+		// }
+		// if (selection != null) {
+		// 	frame.jtree.setSelectionPath(selection);
+		// }
+		changing = false;
+	}
+
+	public Path convertToPath(TreePath treePath) {
+		final Object[] components = treePath.getPath();
+		assert components[0] == frame.rootNode;
+		if (components.length == 1) {
+			return null;
+		}
+		Path.PathBuilder builder = Path.build();
+		builder.tree(Casting.assertCast(TreeNode.class, components[1]).getTree());
+		List<Node> nodes = new LinkedList<>();
+		for (int i = 1; i < components.length; ++i) {
+			TreeNode treeNode = Casting.tryCast(TreeNode.class, components[i]);
+			if (treeNode == null) {
+				return null;
+			}
+			Node node = treeNode.tryCreateNode();
+			if (node == null) {
+				throw new FramsticksException().msg("failed to recreate path").arg("treePath", treePath);
+			}
+			nodes.add(node);
+		}
+		builder.buildUpTo(nodes, null);
+
+		return builder.finish();
+	}
+
+	public TreePath convertToTreePath(Path path) {
+		assert frame.isActive();
+
+		List<Object> accumulator = new LinkedList<Object>();
+		accumulator.add(frame.rootNode);
+
+		for (AbstractNode r : frame.rootNode.getChildren()) {
+			if (r instanceof TreeNode) {
+				TreeNode root = (TreeNode) r;
+				if (root.getTree() == path.getTree()) {
+					accumulator.add(root);
+
+					Iterator<Node> i = path.getNodes().iterator();
+					i.next();
+					TreeNode treeNode = root;
+
+					while (i.hasNext()) {
+						Node node = i.next();
+						treeNode = treeNode.getTreeNodeForChild(node.getObject());
+						if (treeNode == null) {
+							break;
+						}
+						accumulator.add(treeNode);
+					}
+
+					break;
+				}
+			}
+		}
+		return new TreePath(accumulator.toArray());
+	}
+
+	/**
+	 * @return the changing
+	 */
+	public boolean isChanging() {
+		return changing;
+	}
+}
